#include <iostream>
#include "Stack.h"


template <class T>
Stack<T>::Stack()
{
  max = 1;
  items = new T[max];
  top = 0;
}

template <class T>
Stack<T>::~Stack()
{
  delete [] items;
  items = NULL;
}

template <class T>
bool
Stack<T>::isempty()
{
  return (top == 0);
}

template <class T>
void
Stack<T>::push(const T item)
{
  if (top >= max) {
    T *old_items = items;
    int old_max = max;
    max += max;
    items = new T[max];
    for (int i = 0; i < old_max; i++) {
      items[i] = old_items[i];
    }
    delete [] old_items;
  }
  items[top++] = item;
}

template <class T>
bool
Stack<T>::pop(T *item)
{
  if (isempty())
    return false;
  *item = items[--top];
  return true;
}

template class Stack<int>;
template class Stack<char *>;




